
#define ERR (-1)
#define	new(type)	((type *)emalloc(sizeof(type)))

enum{
	/* some rule file formats */
	rfmt = 0, /* raw utf-8 string, default */
	hfmt = 1, /* utf-8 in hex */
	ufmt = 2, /* unicode in hex */
};

typedef struct List List;
struct List{
	void *data;
	List *next;
};

typedef struct Ttab Ttab;
struct Ttab {
	char *frstr;
	char *tostr;
	int	frlen; /* sizeof frstr */
};

typedef struct Trtab Trtab;
struct Trtab {
	Ttab *ttab;
	int max;
	int min;
};


void *emalloc(long n);
char *estrdup(char *str);

int mpow(int n, int k, int mod);
int upprime(int n);

void Btrans(Biobuf *bop, Biobuf *bip);
char *etrans(char *result, char *ep, char *text);
void tabread(char *path);
void Btranslate(int fd);
void stranslate(int fd);
char *ewrite(char *wp, char *ep, char *s, int n);
int Bgetch(Biobuf *bin);
void Bungetch(Biobuf *bip, char *s, int n);
char *trfmt(char *str, int fmt);
int readtable0(Trtab *trtab, char *path, int sortf);
int filetolist(List **rootp, char *path);
int listtotable(Ttab *ttab, List *root);
List *Lpush(List *root, void *data);
List *Lappend(List *p, void *d);
void Lfree(List *p);


int nrule;
List *lroot;
Ttab *ttab;
char *trbuf;
